; this is extremely messy, please don't try to learn from this.

;; Thanks to Philip Montgomery to his HexView.
;; This is my first program for ZShell!
;; To move use arrows. And:
;;  *  and / : move by 0x001C bytes(one Page)
;;  F1 and F2: move by 0x0100 bytes
;;  F4 and F5: move by 0x1000 bytes
;; To edit a location, use Enter and then type the value in hex.
;; You can use + and - to increment or decrement the location byte.
;;
;;            Sami Khawam (a9501901@unet.univie.ac.at ot sKhawam@bigfoot.com)
;;	ported by Greg Milewski ([l0rdg0at@juno.com] || [milewskg@stuy.edu])


#include "ti82.h"
;key defs, saves time for porting from ti85
#include "keys85.inc"
; end key defs, begin vars & title

.org START_ADDR
.db "HexEditor v1.2",$BB," port Greg M.", 0

EditY   = APD_BUF	;TEXT_MEM    
EditX   = EditY+1     
CurPtr  = EditX+1     
EditPtr = CurPtr+2
;;last + 2
; end of vars, begin program

Start:
	ld a, $8C	;rom page 4
	out (2), a
        res 1, (IY+$0D)
	res 2, (IY+$0D)        
	ROM_CALL(DISP_GRAPH)	;fast clearlcd
        ld hl,0
        ld (CURSOR_ROW),hl
        ld hl,Titel1
        ROM_CALL(D_ZT_STR)

        ld hl, (LastPtr)
        ld (EditPtr), hl
        ld (CurPtr), hl

        ld   hl,$0400
	ld (EditY),hl


TitelLoop:
        call GET_KEY
	or a	; cp 0
        jr z, TitelLoop



	ROM_CALL(DISP_GRAPH)	;fast clear screen
        CALL DrawScreen


ProgLoop:
	push hl \ call GET_KEY \ pop hl
	cp $37
        JP Z, Exit
        cp GK_F2
        JP Z, JumpDown
        cp GK_F1
        JP Z, JumpUp
        cp GK_SLASH
        JP Z, PageUp
        cp GK_STAR
        JP Z, PageDown
        cp GK_F5
        JP Z, bigjumpdn
        cp GK_F4
        JP Z, bigjumpup
        cp GK_PLUS
        jr z, IncVal
        cp GK_MINUS
        jr z, DecVal
        cp GK_ENTER
        JP Z, EditVal
;/-used from Jimmy Mardell's Ztetris -\
	dec a
	jr z,DrawDown
	dec a
	jr z,DrawLeft
	dec a
	jp z,DrawRight
	dec a
	jr z,DrawUp
;end of Mardell routine

        jr ProgLoop



DoAdv1:
        push hl
        ld de, (CurPtr)
	add hl, de
	ld (CurPtr), hl
        pop hl
DoAdv2:
        ld de, (EditPtr)
        add hl, de
        ld (EditPtr), hl
DoDraw:
        CALL DrawScreen
        jr ProgLoop


DrawDown:
        ld hl, 4
        ld a, (EditY)
        cp 7
        jr z, DoAdv1
        inc a
        ld (EditY), a
        jr DoAdv2

DrawUp:
        ld hl, -4
        ld a, (EditY)
        or a	;cp 0
        jr z, DoAdv1
        dec a
        ld (EditY), a
        jr DoAdv2


DrawLeft:
        ld a, (EditX)
        cp 4 	;5
        jr z, DoDraw
        sub 2
        ld (EditX), a
        ld hl, -1
        jr DoAdv2


DrawRight:
        ld a, (EditX)
        cp 10	;11
        jr z, DoDraw
        add a, 2
        ld (EditX), a
        ld hl, 1
        jr DoAdv2


IncVal:
        ld hl, (EditPtr)
        ld a, (hl)
        inc a
        ld (hl), a
        jr DoDraw

DecVal:
        ld hl, (EditPtr)
        ld a, (hl)
        dec a
        ld (hl), a
        jr DoDraw


PageDown:
        ld hl, 001Ch
        jr DoAdv1

PageUp:
        ld hl, -001Ch
        jr DoAdv1

JumpDown:
	ld hl, 0100h
        jr DoAdv1

JumpUp:
	ld hl, - 0100h
        jr DoAdv1




bigjumpdn:
	ld hl, 1000h
        JP DoAdv1

bigjumpup:
	ld hl, - 1000h
        JP DoAdv1


EditVal:
        ld a, (EditY)
        ld (CURSOR_ROW), a
        ld a, (EditX)
        ld (CURSOR_COL), a
        set 3, (IY+$05)

        ld a, '_'
        ROM_CALL(TX_CHARPUT)
        ROM_CALL(TX_CHARPUT)

        ld a, (EditY)
        ld (CURSOR_ROW), a
        ld a, (EditX)
        ld (CURSOR_COL), a

        call GetVal
        push af
        add a , a
        add a , a
        add a , a
        add a , a
        ld b, a
        pop af
        add a, '0'
        ROM_CALL(TX_CHARPUT)

        CALL GetVal
        push af
        or b
        ld b, a
        pop af
        add a, '0'
        ROM_CALL(TX_CHARPUT)

        ld hl, (EditPtr)
        ld (hl), b

        res 3, (IY+$05)
        
        jp DoDraw


GetVal:
        push hl
        push bc
        ld   hl,LetterConvertTable-1 ;(orig de)Point to one before, since we always inc once

ConvertLoop:
        push hl
        call GET_KEY
        pop  hl
	or a        ;cp   0
        jr   z,ConvertLoop
        push hl                      ;save away...
        ld   b,a
        ld   c,0
ConversionLoop:
        inc  hl
        djnz ConversionLoop          ;After this, we have the correct offset...
        ld   a,(hl)
        pop  hl
	or a	;cp   0
        jr   z,ConvertLoop           ;Invalid key
        dec  a
        pop  bc
        pop  hl
        ret                          ;Value is in acc



Exit:

        ld hl, LastPtr

        ld a, (CurPtr)
        ld (hl), a
        inc hl
        ld a, (CurPtr+1)
        ld (hl), a

        ret


;;;;;;;;DrawScreen function
DrawScreen:
	push hl

	ld hl,0
	ld (CURSOR_ROW), hl

	ld hl, (CurPtr)
        ld b, 8  
NextRow:
	CALL DisplayLine

        djnz NextRow

        ld a, (EditY)
        ld (CURSOR_ROW), a
        ld a, (EditX)
        ld (CURSOR_COL), a
        set 3, (IY+$05)
        ld hl, (EditPtr)
        ld a, (hl)
	CALL PrintHex
        res 3, (IY+$05)

        pop hl
	ret
;;end DrawScreen

;;;;;Function DisplayLine
DisplayLine:			; hl -> start of dump
	push de
	push bc

	set 3, (IY+$05)
	ld a, h
	CALL PrintHex
	ld a, l
	CALL PrintHex		; Print address being decoded
	res 3, (IY+$05)

        push hl

        ld b, 4                 ; Do 4 bytes
NextChar:
	ld a, (hl)
	CALL PrintHex
        inc hl
        djnz NextChar

        pop hl

        ld b, 4                 ; Do 4 bytes

NextChar0:
        ld a, (hl)
        cp $D6		;if a=carraige return/line feed, replace w/ ":"
        jr nz, NextChar1
        ld a, $3A	;":"
NextChar1:
        ROM_CALL(TX_CHARPUT)
        inc hl
        djnz NextChar0

        pop bc
	pop de
	ret
;;;end display line


;;;;;;;;;;;PrintHex function
PrintHex:			; de destroyed
	push bc
	push de

	ld b, a
	and $0f0
	rrca
	rrca
	rrca
	rrca

	add a, 30h
	cp $3a
	jr c, hexnumber0
	add a, $7
hexnumber0:
        ROM_CALL(TX_CHARPUT)

	ld a, b
	and $0f

	add a, 30h
	cp $3a
	jr c, hexnumber1
	add a, $7
hexnumber1:
        ROM_CALL(TX_CHARPUT)
	pop de
	pop bc
	ret
;;;;;;;;;end PrintHex function

	    ;0123456789ABCDEF
Titel1: .db "HexEdit - Sami K"	;,0
Titel2: .db $7F," port: Greg M ",$7F
        .db 6,"&",7," &  * & /    "
        .db "Y=,WIN,TRCE,GRAF"
        .db " Enter to edit  "
        .db "+/- inc. / dec. ",0

LetterConvertTable:         ;For converting keys into letters
;updated ti82 table
   .db 0,0,0,0,0,0,0,0,0
   .db 0,0,0,0,0       
   .db 0,0             
   .db 0,4,7,$0A,0     
   .db 0               
   .db 0,0             
   .db 0,3,6,9,0,$10   
   .db $0D,0           
   .db 1,2,5,8,0,$0F   
   .db $0C,0,0,0       
   .db 0,0,0,$0E       
   .db $0B,0,0,0,0,0,0,0,0,0      

LastPtr: .dw 0	;$0000

.END
      